Ruby - Bug #3014

select + read for STDIN unexpected result on Windows

03/26/2010 10:53 AM - phasis68 (Heesob Park)

Backport:

Status: Closed

Priority: Normal

Assignee: usa (Usaku NAKAMURA)

Target version: 1.9.2

ruby -v: ruby 1.9.2dev (2010-03-26 trunk 27048)
[i386-mswin32_90]

Description

=begin

| found that select and read combination for STDIN results "ru by . e x e" on Windows.

Consider following code:
select([STDIN],nil,nil,10);puts STDIN.read(8)

| entered "test1234\n" for input.
On 1.8.6, it works fine.

C:>ruby -ve 'select([STDIN],nil,nil,10);puts STDIN.read(8)'
ruby 1.8.6 (2010-02-04 patchlevel 398) [i386-mingw32]
test1234

test1234

On1.9.x, itresults "ruby".

C:work>ruby -ve 'select([STDIN],nil,nil,10);puts STDIN.read(8)'
ruby 1.9.1p129 (2009-05-12 revision 23412) [i386-mingw32]
test1234

ruby

C:\work>ruby -ve 'select([STDIN],nil,nil,10);puts STDIN.read(8)'
ruby 1.9.2dev (2010-03-26 trunk 27048) [i386-mswin32_90]
test1234

ruby

C:\work>ruby -ve 'select([STDIN],nil,nil,10);p STDIN.read(8)'
ruby 1.9.2dev (2010-03-26 trunk 27048) [i386-mswin32_90]
test1234

"r\x00u\x00b\x00y\x00"

The result string is actually "ru by . e x €" plus some garbage.
=end

History

#1 - 03/26/2010 01:22 PM - yugui (Yuki Sonoda)

- Assignee set to usa (Usaku NAKAMURA)

- Target version changed from 2.0.0 to 1.9.2

=begin

=end

#2 - 03/26/2010 07:12 PM - phasis68 (Heesob Park)
=begin

| found that STDIN.read(n) works when n >= 41.
| guess this bug is caused by PeekConsolelnput's bug or side effect.

Here is a guick and dirty patch.

---win32.c  2010-03-26 19:04:28.502025030 +0900
+++ win32.c.new 2010-03-26 19:03:05.138310126 +0900
@@ -4851,6 +4851,10 @@

return _read(fd, buf, size);

1
o f((_osfile(fd) & FDEV) && size <= 40) {
- I
*}
e MTHREAD_ONLY (EnterCriticalSection(&(_pioinfo(fd)->lock)));

if (Isize || _osfile(fd) & FEOFLAG) {

=end

#3 - 05/27/2010 10:37 PM - usa (Usaku NAKAMURA)
- Status changed from Open to Closed
- % Done changed from 0 to 100

=begin

This issue was solved with changeset r28035.
Heesob, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.
May Ruby be with you.

=end
